Package docking.widgets.fieldpanel.field

# Class StrutFieldElement

java.lang.Object
docking.widgets.fieldpanel.field.StrutFieldElement

All Implemented Interfaces:
  `FieldElement`

public class StrutFieldElement extends Object implements FieldElement
Used to force a clip to happen by using this field with space characters and size that far exceeds the available painting width.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StrutFieldElement(FieldElement baseElement, int width)`
  Constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `char`
  `charAt(int index)`
  Returns the character at the given index.
  `FieldElement`
  `getBaseType()`
  Returns the base type replaced by this strut; may be null
  `int`
  `getCharacterIndexForDataLocation(int dataRow, int dataColumn)`
  Returns the character index appropriate for the given data location
  `Color`
  `getColor(int charIndex)`
  Returns the color for a given character within this element, since different colors may be applied to different characters.
  `RowColLocation`
  `getDataLocationForCharacterIndex(int characterIndex)`
  Translates the given character index to a data location related to the data model, as determined by the FieldFactory.
  `FieldElement`
  `getFieldElement(int characterOffset)`
  Returns the inner-most FieldElement inside this field element at the given location
  `int`
  `getHeightAbove()`
  Returns the amount of height above the baseline of this element.
  `int`
  `getHeightBelow()`
  Returns the amount of height below the baseline of this element.
  `int`
  `getMaxCharactersForWidth(int stringWidth)`
  As the name implies, this method returns the maximum number of characters from this field element that will fit within the given width.
  `int`
  `getStringWidth()`
  Returns the string width of this element.
  `String`
  `getText()`
  Returns the text contained by this field element.
  `int`
  `length()`
  Returns the length of the text within this element.
  `void`
  `paint(JComponent c, Graphics g, int x, int y)`
  Paints the text contained in this field element at the given x,y screen coordinate using the given Graphics object.
  `FieldElement`
  `replaceAll(char[] targets, char replacement)`
  Returns a new FieldElement with all occurrences of the target characters replaced with the given replacement character.
  `FieldElement`
  `substring(int start)`
  Returns a new FieldElement containing just the characters beginning at the given index.
  `FieldElement`
  `substring(int start, int end)`
  Returns a new FieldElement containing just the characters beginning at the given start index (inclusive) and ending at the given end index (exclusive).
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### StrutFieldElement

    public StrutFieldElement(FieldElement baseElement, int width)
    Constructor. Clients may choose to pass
    Parameters:
      `baseElement` - the base type replaced by this strut; may be null if no type is being replaced
      `width` - the width of this strut class

- ## Method Details

  - ### getBaseType

    public FieldElement getBaseType()
    Returns the base type replaced by this strut; may be null
    Returns:
      the base type replaced by this strut; may be null

  - ### charAt

    public char charAt(int index)
    Description copied from interface: `FieldElement`
    Returns the character at the given index.
    Specified by:
      `charAt` in interface `FieldElement`
    Parameters:
      `index` - the index of the character in this field element.
    Returns:
      the character at the given index.

  - ### getCharacterIndexForDataLocation

    public int getCharacterIndexForDataLocation(int dataRow, int dataColumn)
    Description copied from interface: `FieldElement`
    Returns the character index appropriate for the given data location
    Specified by:
      `getCharacterIndexForDataLocation` in interface `FieldElement`
    Parameters:
      `dataRow` - the row in the data model as determined by the creating field factory.
      `dataColumn` - the column in the data model as determined by the creating field factory.
    Returns:
      the character index appropriate for the given data location; -1 if this field does not contain the given location

  - ### getDataLocationForCharacterIndex

    public RowColLocation getDataLocationForCharacterIndex(int characterIndex)
    Description copied from interface: `FieldElement`
    Translates the given character index to a data location related to the data model, as determined by the FieldFactory.
    Specified by:
      `getDataLocationForCharacterIndex` in interface `FieldElement`
    Parameters:
      `characterIndex` - The character index to translate.
    Returns:
      The data location in the model coordinates.

  - ### getColor

    public Color getColor(int charIndex)
    Description copied from interface: `FieldElement`
    Returns the color for a given character within this element, since different colors may be applied to different characters.
    Specified by:
      `getColor` in interface `FieldElement`
    Parameters:
      `charIndex` - The character index
    Returns:
      the color for a given character within this element.

  - ### getFieldElement

    public FieldElement getFieldElement(int characterOffset)
    Description copied from interface: `FieldElement`
    Returns the inner-most FieldElement inside this field element at the given location
    Specified by:
      `getFieldElement` in interface `FieldElement`
    Parameters:
      `characterOffset` - the character offset.
    Returns:
      the inner-most FieldElement inside this field element at the given location

  - ### getHeightAbove

    public int getHeightAbove()
    Description copied from interface: `FieldElement`
    Returns the amount of height above the baseline of this element.
    Specified by:
      `getHeightAbove` in interface `FieldElement`
    Returns:
      the amount of height above the baseline of this element.

  - ### getHeightBelow

    public int getHeightBelow()
    Description copied from interface: `FieldElement`
    Returns the amount of height below the baseline of this element.
    Specified by:
      `getHeightBelow` in interface `FieldElement`
    Returns:
      the amount of height below the baseline of this element.

  - ### getMaxCharactersForWidth

    public int getMaxCharactersForWidth(int stringWidth)
    Description copied from interface: `FieldElement`
    As the name implies, this method returns the maximum number of characters from this field element that will fit within the given width.
    Specified by:
      `getMaxCharactersForWidth` in interface `FieldElement`
    Parameters:
      `stringWidth` - The width constraint
    Returns:
      the maximum number of characters from this field element that will fit within the given width.

  - ### getStringWidth

    public int getStringWidth()
    Description copied from interface: `FieldElement`
    Returns the string width of this element. The width is based upon the associated FontMetrics object within this element.
    Specified by:
      `getStringWidth` in interface `FieldElement`
    Returns:
      the string width of this element.

  - ### getText

    public String getText()
    Description copied from interface: `FieldElement`
    Returns the text contained by this field element.
    Specified by:
      `getText` in interface `FieldElement`
    Returns:
      the text contained by this field element.

  - ### length

    public int length()
    Description copied from interface: `FieldElement`
    Returns the length of the text within this element. This is a convenience method for calling `getText().length()`.
    Specified by:
      `length` in interface `FieldElement`
    Returns:
      the length of the text within this element.

  - ### paint

    public void paint(JComponent c, Graphics g, int x, int y)
    Description copied from interface: `FieldElement`
    Paints the text contained in this field element at the given x,y screen coordinate using the given Graphics object.
    Specified by:
      `paint` in interface `FieldElement`
    Parameters:
      `c` - the component being painted.
      `g` - the Graphics object used to paint the field text.
      `x` - the horizontal screen position to paint
      `y` - the vertical screen position to paint.

  - ### replaceAll

    public FieldElement replaceAll(char[] targets, char replacement)
    Description copied from interface: `FieldElement`
    Returns a new FieldElement with all occurrences of the target characters replaced with the given replacement character.
    Specified by:
      `replaceAll` in interface `FieldElement`
    Parameters:
      `targets` - The array of characters to replace.
      `replacement` - The replacement character.
    Returns:
      a new FieldElement with all occurrences of the target characters replaced with the given replacement character.

  - ### substring

    public FieldElement substring(int start)
    Description copied from interface: `FieldElement`
    Returns a new FieldElement containing just the characters beginning at the given index.
    Specified by:
      `substring` in interface `FieldElement`
    Parameters:
      `start` - The starting index (inclusive) from which to substring this element.
    Returns:
      a new FieldElement containing just the characters beginning at the given index.

  - ### substring

    public FieldElement substring(int start, int end)
    Description copied from interface: `FieldElement`
    Returns a new FieldElement containing just the characters beginning at the given start index (inclusive) and ending at the given end index (exclusive).
    Specified by:
      `substring` in interface `FieldElement`
    Parameters:
      `start` - The starting index (inclusive) from which to substring this element.
      `end` - The end index (exclusive) to which the substring will be performed.
    Returns:
      a new FieldElement containing just the characters beginning at the given index.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`